% a program to choose scale and classify points
close all;
clear all;


TARGETSIZE=320*240;

% input a source picture
%pict = getpict( 4 );
%pict = double( imread( '../../images/stile.jpg' ) ) /255;
%pict = double( imread( '../../images/rushmore.jpg' ) ) /255;

%pict = double( imread( '../images/a.jpg' ) ) /255;

%pict = double( imread( '../../images/tiger.jpg' ) ) /255;
%pict = double( imread( '../../images/mosaics/bison6.jpg' ) ) /255;
%pict = double( imread( '../../images/mushroom.jpg' ) ) /255;

pict = double( imread( 'swallowtail.jpg' ) ) /255;

resize_ratio=sqrt(TARGETSIZE/(size(pict,1)*size(pict,2)));
pict=imresize(pict,round([size(pict,1)*resize_ratio,size(pict,2)*resize_ratio]),'bicubic');
pict(pict<0)=0;
pict(pict>255)=255;

%pict = double( imread('../../images/eagles.jpg' ) )/255;

%pict = double( imread('../../images/Prague.jpg' ) )/255;

%pict = double( imread('../../images/Bath.jpg' ) )/255;

% qpict(:,:,1) = imdilate( pict(:,:,3) < 0.5,  strel('square',3 ));
% qpict(:,:,2) = 0;
% qpict(:,:,3) = pict(:,:,1) < 0.5;
% qpict = double(qpict );
% mask = (qpict(:,:,1) == 0) & (qpict(:,:,3) == 0);
% mask = double(mask);
% qpict(:,:,1) = qpict(:,:,1).*(mask == 0 ) + mask;
% qpict(:,:,2) = mask;
% qpict(:,:,3) = qpict(:,:,3).*(mask == 0 ) + mask;
% pict = qpict;
% figure;
% imshow(  pict );

% pict = getpict(4);

%pict = double( imread( 'DSCF0130.JPG' ) ) /255;

% imshow( pict );
% drawnow;

% get the jnd map of the picture
%load jndpict;
jpict = jnd_pict(pict);
%save 'jndpict.mat' jpict;

load coherencedata;
load classifier;
Nsamp = 16; % use 16 samples
[samp(1,:), samp(2,:)] = make_samples( Nsamp ); % sample around the unit circle
mask = []; % empty set of masks

N = size(pict);
spict= zeros(N(1),N(2) ); % scale map
vpict = zeros(N(1),N(2) ); % visibility map
cpict = zeros(N(1),N(2)); % coherence map
tpict = zeros( N(1),N(2), 5);  % type map
mpict = zeros(N(1),N(2)); % coherence measure map

minscale = 3; % minimum reliable scale
% now iterate over each pixel
hh = waitbar(0,'classifiying' );
for j = (minscale+1):(N(1)-minscale)
  waitbar( j/N(1),hh );
  for i = (minscale+1):(N(2)-minscale)
    scale = minscale; % initiate scale
    while (j-scale > 0 & i-scale > 0 & j+scale < N(1) & i+scale < N(2))
       if  size(mask,2) < scale % need a new mask
        mask = mask_new( mask, scale );
      end
      w = pict( j-scale:j+scale, i-scale:i+scale, : ); % window
      u = sum(sum(  w.* mask{scale}.dx ) ); % df/dx
      v = sum(sum(  w.* mask{scale}.dy )); % df/dy
      d  = sqrt(sum(u.^2 + v.^2)); % Euclidean distance
      vpict(j,i) = 0.5*(erf( (d-jpict(j,i,1)) ./ jpict(j,i,2) ) + 1); % jnd estimate;
      if vpict(j,i) > 0.5 % probably visible
        spict(j,i) = scale; % record scale
        w = location2window( pict, [i,j], samp, 1:scale ); % circularly sampled window
        jw = location2window( jpict, [i,j], samp, 1:scale );   % grab jnd data too
        [da,dr] = window_radiff( w, pict(j,i,:) );  % differential structure
        f = type_window2feature( da, dr, jw, 1:scale ); % feature vector
        [p,ps] = type_feature_posterior( f, classifier ); % classifiy feature vector
        [pc,pm] = coherence_window_prob( w, coherencedata );
        % [pm,t] = max(p); % t is type
        tpict(j,i,:) = p;
        % cpict(j,i) = pc;
        mpict(j,i) = pm;
        break;
      end
      scale = scale+1; % next scale
    end % while 
  end % for i
end % for j
close( hh );
figure;
imshow( tpict(:,:,2:4) );

mu = 0.5;
sigma = 1/1000;
for j = (minscale+1):(N(1)-minscale)
  for i = (minscale+1):(N(2)-minscale)
    scale = spict(j,i);
    w = mpict(j-scale:j+scale, i-scale:i+scale );
    w = 1 - pictNorm( w );
    w = (erf( (w - mu)/sigma ) + 1)/2;
    cpict(j,i) = w(scale+1,scale+1);
  end
end

kpict(:,:,1) = tpict(:,:,1).*cpict;
kpict(:,:,2) = tpict(:,:,2).*cpict;
kpict(:,:,3) = tpict(:,:,3).*cpict;
kpict(:,:,4) = tpict(:,:,4).*cpict;
kpict(:,:,5) = tpict(:,:,5).*cpict;

figure;
imshow( kpict(:,:,2:4) );

ipict = double( bwmorph( sum( kpict(:,:,2:4), 3 ) > 0.5, 'clean' ) );
kpict(:,:,1) = kpict(:,:,1).*ipict;
kpict(:,:,2) = kpict(:,:,2).*ipict;
kpict(:,:,3) = kpict(:,:,3).*ipict;
kpict(:,:,4) = kpict(:,:,4).*ipict;
kpict(:,:,5) = kpict(:,:,5).*ipict;

figure;
imshow( kpict(:,:,2:4) );

a = kpict(:,:,2:4);
b = sum(a,3) > 0.5; % bwmorph(sum(a,3) > 0.5, 'thin', Inf );
b(:,:,2) = b(:,:,1);
b(:,:,3) = b(:,:,1);
b = double(b);
ab = a.*b;
c(:,:,1) = rgb2gray( pict );
c(:,:,2) = rgb2gray( pict );
c(:,:,3) = rgb2gray( pict );

mask = ab > 0.5;
d = 0.75*c.*(mask == 0) + ab.*(mask == 1 );

imshow(d);
return;

% 
% cpict = ones( N(1),N(2) );
% for j = (minscale+1):(N(1)-minscale)
%   for i = (minscale+1):(N(2)-minscale)
%     [m,t] = max( tpict(j,i,:) );
%     if t == 2
%        scale = spict(j,i);
%        [i1,j1] = meshgrid( i-scale:i+scale, j-scale:j+scale );
%        k = [i1(:) j1(:)]'; % easy indices       
%        w = pict( j-scale:j+scale, i-scale:i+scale, : ); % window
%        jw = pict( j-scale:j+scale, i-scale:i+scale, : ); % jnd window
%        M = size(w,1)*size(w,2);
%        ww = [ reshape( w(:,:,1), M, [] ), reshape( w(:,:,2),M,[] ), reshape( w(:,:,3),M,[] ) ];
%        dw = dist2( ww, ww ); % Euclidean distances between colours
%        dwm = max(max(dw)); %
%        [j1,i1] = find( dw == dwm);
%        p1 = k(  :, j1(1) ); % locate the points in the image
%        p2 = k( :, i1(1) ); % that represent maximum change
%        e1 = p1 - p2;
%        e1 = e1 / norm(e1); % major axis
%        p0 = [i; j];
%        for s = 1:scale
%          p = round( e1*s );
%          q = p0+p;
%          cpict( q(2),q(1) ) = cpict( q(2),q(1) )/2;
%          q = p0-p;
%          cpict( q(2),q(1) ) = cpict( q(2),q(1)) /2;
%        end
%     end % t
%   end
% end

