close all;
clear all;

Nsample = 16;
rad = 4;

% initiate training data
if FileExists( 'coherence_trainingdata.mat' )
  load coherence_trainingdata;
else
  coherence_trainingdata = coherence_training_data_init;
end

save 'coherence_trainingdata.mat'  coherence_trainingdata;

% choose a picture
fprintf('---select a picture ---\n');
fullname = training_pict_choose( coherence_trainingdata );

% run a training session
fprintf('--- Collect training data  ---\n');
coherence_trainingdata = training_session( fullname, rad, coherence_trainingdata );
save 'coherence_trainingdata.mat'  coherence_trainingdata;

% make a set of features
fprintf('--- Making features ---\n');
featuredata = training2coherence_measure( coherence_trainingdata, Nsample );
save 'featuredata.mat'  featuredata;

% determine a distribution model
h = distribution1D_plot( featuredata.feature, featuredata.type, coherence_trainingdata.typecolour, 1 );
x = 0:0.01:0.5;
mu = 0.06;
sigma = 1/30;
y = (erf( (x-mu)/sigma )+1)/2;
plot( x,y );

% save model as coherence data
coherencedata.mu = mu;
coherencedata.sigma = sigma;
save 'coherencedata.mat' coherencedata;

% make a picture
load coherencedata;
rad =3;
Nsample = 16;
[x,y] = make_samples( Nsample );

pict = getpict(1);
imshow( pict );
drawnow;

mu = 0.01;
sigma = 1/10;
%coherencedata.mu = mu;
%coherencedata.sigma = sigma;

cpict = coherence_prob_pict( pict, [x;y], 1:rad, coherencedata );

figure;
imshow( cpict );

return;
