function [p,ms] = coherence_window_prob( w, coherencedata )

% p = coherence_window_prob( w, coherencedata )
% Estimate the probabilty that a window, w, 
% is coherent - given coherence data.

% get the coherence matrix
m = coherence_matrix( w );

%ms = max(max(m));

ms = sum(sum(m))/ prod(size(m));

% estimate probability of coherence
p = 1-exp( -0.5*((ms-coherencedata.mu)/coherencedata.sigma).^2 );


return;
