function h = distribution1D_plot( data, datatype, colour, scale )

Ntype = length(unique(datatype));

maxx = max( data );
minx = min( data );
dx = 10^round(mean(log10(data+eps))) *scale;
x = minx:dx:maxx;

for i = 1:Ntype
  d(i,:) = hist( data(datatype==i), x );
end

ds = sum( d, 1 );
for i = 1:Ntype
  p(i,:) = d(i,:) ./ max( eps, ds );
end

figure;
hold on;
for i = 1:Ntype
  h{i} = plot( x, p(i,:), 'color', colour(i,:) );
end

return;


for i = 1:Ntype
  dummy = bar( p(i,:) );
  set(dummy, 'FaceColor', colour(i,:) );
end
