% measure the mean and standard devitaion of 'coherence matrix' for
% rings drawn from a random field

close all;
clear all;

rmax = 5;

Nsample = 8:8:32;


for kk = 1:length(Nsample)
  
  clear d;
  clear ent;
  
  N = 2*rmax+1; % width
  i = rmax + 1; % centre
  j = rmax + 1;
  [x,y] = make_samples( Nsample(kk) );
  rad =0:rmax;
  d = zeros( length(rad) );
  mask = tril( ones(length(rad)), -1 ) == 1;
  
  for k = 1:100
    pict(:,:,1) = rand(N,N);
    if rand < 0.5
      pict(:,:,2) = rand(N,N); 
      pict(:,:,3) = rand(N,N); 
    else
      pict(:,:,2) = pict(:,:,1);
      pict(:,:,3) = pict(:,:,1);
    end
    w = location2window( pict, [i;j], [x;y], 0:rmax );
    
    % compute the Euclidean distance between each pair of rings
    for r1 = 1:length(rad)
      for r2 = 1:length(rad)
        d(r1,r2,k) = sqrt( sum(sum( (w(r1,:,:) - w(r2,:,:)) .^2,3)) / Nsample(kk) );
      end
    end
    
    h = d(:,:,k);
    h = h(mask);
    hs = sum(h);
    if hs < eps
      ent(k) = 0;
    else
      h = h(h > eps) / hs;
      ent(k)= sum( h.*log(h) );
    end % end if hs

  end % end k
  
  md{kk}.d = d;
  md{kk}.dmean = mean(d,3);
  md{kk}.sddev = std(d,[],3 );
  md{kk}.ent = ent;
  md{kk}.emean = mean(ent);
  md{kk}.smean = std(ent);
end

z = [];
for kk = 1:length(Nsample)
  z = [z md{kk}.ent];
end

dd = zeros( length(rad),length(rad),0);
for kk = 1:size(md,2)
  dd= cat(3,dd,md{kk}.d);
end
 
md = mean( dd, 3 );
sd = std( dd, [], 3 );

return;

coherencedata.mu =  mean(z);
coherencedata.sigma = std(z);

cd ..
save 'coherencedata.mat' coherencedata;
cd test


 
