function jnddata = jnd_auxilluary_make( jnddatain )

% Add auxillary data to the jnd model to allow faster use

jnddata = jnddatain;

N = Octree_size( jnddata );
for i = 1:N
  index = Octree_getdata( jnddata, i );
  cornerp = jnddata.point(:, index );
  maxp = max( cornerp, [], 2);
  minp = min( cornerp, [], 2 );
  d1 = cornerp - repmat(minp,1,8);
  d2 = repmat(maxp,1,8) - cornerp;
  logicalp = (d1 >= d2);

  for ii = 1:8
    for jj = 1:8
      if ( jnddata.ordering(:,jj) == logicalp(:,ii) )
        order(ii) = jj;
      end
    end
  end

  if any(order ~= [1:8] )
    break;
  end
  
  jnddata.aux{i}.minp = minp;
  jnddata.aux{i}.midp = (maxp + minp)/2;
  jnddata.aux{i}.maxp = maxp;
  jnddata.aux{i}.dp = maxp - minp;
  
end

return;
