function fest = jnd_estimate( p, jnddata, s )

% fest = jnd_estimate( p, jnddata, s )
% Estimate the jnd function value at the point p, given a jnd model
% If s is given, and s == 2, then the standard deviation is computed too

% get the leaf to point is in
leaf = jnd_locate_leaf( p(:), jnddata );

% locate samples in list
% index = Octree_getdata( jnddata, leaf );% this is the "proper" way
index = jnddata.node{leaf}.data; % this way is faster - but dodgy from s/w view

% grab the function values at the leaf corners
cornerf = jnddata.func(:, index );

% estimate the value using tri-linear interpolation
fest(1,:) = LinInterp3D( p, jnddata.aux{leaf}.minp, jnddata.aux{leaf}.dp, cornerf(1,:) );
fest(2,:) = LinInterp3D( p, jnddata.aux{leaf}.minp, jnddata.aux{leaf}.dp, cornerf(2,:) );
 

return;

