function leaf = jnd_locate_leaf( p, jnddata )

% leaf = jnd_locate_leaf( p, jnddata)
% return the index of the octree structure in which point p resides.
% If the points is on a boundary, then return all leaves
% If on return leaf is empty (isempty(leaf)==1), then the point lies in no leaf
% (it is outside the volume).

w = [1; 2; 4];
leaf = jnddata.root;

while ~isempty( jnddata.node{leaf}.child )

  child = jnddata.node{leaf}.child;  
  for j = 1:8
    minp = jnddata.aux{child(j)}.minp;
    maxp = jnddata.aux{child(j)}.maxp;
    if all((minp <= p) & (maxp >= p))
      break;
    end
  end
  leaf = jnddata.node{leaf}.child(j);

end

return;



