function f = jnd_measure_trial( p, tol, Nedge )

% f = jnd_measure_trial( p, tol, Nedge )
% Measure the jnd at point p - several times - until the ratio of absolute
% difference between successive means to the first of the means
% falls below a threhold.

if nargin < 3
  Nedge = 49;
end
if nargin < 2
  tol = 1E-4;
end

for i = 1:5
  f(i) = jnd_measure( p, rand, Nedge );
end
mfold = mean(f);

carry_on = 1;
while carry_on
  f = [f jnd_measure(p,rand,Nedge)];
  mf = mean(f);
  carry_on = abs(mf-mfold)/mf < tol;
end

return;




