function jnddata = jnd_point_train( p, jnddata, tol, Nedge )

% jnddata = jnd_point_train( p, jnddata, tol, Nedge )
% Train the jnd data at the specified point, p.
% Show the user a picture based on the current estimate, and allow them
% to update it if they wish.

% estimate the jnd value
fest = jnd_estimate( p, jnddata, 2 );

% make a picture of it
pict1 = jnd_make_pict( p, fest(1)-3*fest(2), Nedge );
pict2 = jnd_make_pict( p, fest(1), Nedge );
pict3 = jnd_make_pict( p, fest(1)+3*fest(2), Nedge );
figure;
subplot( 1,3,1 );
imshow( pict1 );
subplot( 1,3,2 );
imshow( pict2 );
subplot( 1,3,3 );
imshow( pict3 );

% if the user thinks this is a poor estimate, allow them to change it
fprintf('do you accept the middle image as a threshold image? (y/n)\n');
sui = '';
badinput = 1;
while badinput
  badinput = 0;
  sui = input('','s');
  switch sui
  case 'y'
  case 'n'
  otherwise
    fprintf('!!! bad input !!!\n');
    badinput = 1;
  end
end
close;

if sui == 'n'
  % is unhappy with estimate : make a measure 
  f = jnd_measure_trial( p, tol, Nedge );
  jnddata = jnd_sample_include( jnddata, p, f );
end

return;
