function vpict = jnd_prob_pict( pict, jnddata, r,x,y, thrsh, jpict )

% vpict = jnd_prob_pict( pict, jnddata )
% Return a probability map of visible pixels, given the jnd model


Nring = r;
Nsample = size(x,2);

N = size( pict(:,:,1) );
vpict = zeros( N(1),N(2) );

jnd = zeros( 2, size(x,2) );
d = zeros( 1, size(x,2) );


if nargin < 6
  thrsh = 1;
end

% make a jnd picture
if nargin < 7
  jpict = zeros( N(1), N(2), 2 );
  for j = 1:N(1)
    for i = 1:N(2)
      jpict( j,i,:) = jnd_estimate( pict(j,i,:), jnddata );
    end
  end
end


for j = (r+1):(N(1)-r)
  for i = (r+1):(N(2)-r)
       
    % get a window
    w = location2window( pict, [i;j], [x;y], 1:r );
    
    [da,dr] = ra_diff( w, pict(j,i,:) );
    d = sum( sqrt((da.^2 + dr.^2)), 3 );
    for jj = 1:Nring
      u = i + round( jj*x ); 
      v = j + round( jj*y );
      for ii = 1:Nsample
        jnd = jpict( v(ii), u(ii), : );
        % d(jj,ii) = (1+erf( (d(jj,ii) - thrsh*jnd(1)) / jnd(2)  ))/2;
        d(jj,ii) = d(jj,ii) / jnd(1);
      end
    end
    %vpict(j,i) = mean( max(d,[],2) );
    vpict(j,i) = mean(mean( d) );

%     % estimate magnitude of differential
%     ww = [w(:,end,:) w w(:,1,:)];
%     for jj = 1:Nring
%       % locate of samples on jj'th ring
%       u = i + round( jj*x ); 
%       v = j + round( jj*y );
%       for ii =1:Nsample
%         % angular differential
%         dn = ww(jj,ii,:);
%         dp = ww(jj,ii+2,:);
%         da = (dp - dn) / 2;
%         
%         % radial differential
%         dp = w(jj,ii,:);
%         if ii > 1
%           dn = ww(jj,ii-1,:);
%         else
%           dn = pict(j,i,:);
%         end
%         dr = dp - dn;
%         
%         % gradient magnitude
%         d(jj,ii) = sqrt( sum(da.^2) + sum(dr.^2) ); %sqrt( sum(da.^2) + sum(dr.^2) );
%         
%         % perceptual measures
%         jnd = jpict( v(ii), u(ii), : );
%         d(jj,ii) = (1+erf( (d(jj,ii) - thrsh*jnd(1)) / jnd(2)  ))/2;
%       end
%     end
    
    % decide probability of being visible
 %   vpict(j,i) = mean( mean(d,2) );
    
  end
end


return;

%     w = location2window( pict, [i;j], [x;y], r );
% 

%     
%     % decide if the window contains a visible feature
%     for jj = 1:1
%       for ii = 1:Nsample
%         jnd = jnd_estimate( w(jj,ii,:), jnddata );
%         p(jj,ii) = (1+erf( (d(jj,ii) - thrsh*jnd(1))/jnd(2) ))/2;
%       end
%     end
    
%     % vpict(j,i) = max(max( p ));
%     % get a window of samples
%     window = samplepict( pict, j,i,x,y );
%     % compute distance from one to the next, and the jnd at each place
%     window = [window window(:,1)];
%     for k = 1:size(x,2)
%       jnd(:,k) = jnd_estimate( window(:,k), jnddata );
%       d(k) = norm(window(:,k) - window(:,k+1));
%     end
%     % compute the "forward" probs
%     v1 = (erf((d - thrsh*jnd(1,:))./jnd(2,:)) + 1)/2;
%     % and the backward probs
%     jnd = [jnd(:,2:end) jnd(:,1)];
%     v2 = (erf((d - thrsh*jnd(1,:))./jnd(2,:)) + 1)/2;
%     % us the mean of the probabilities as visibility
%     vpict(j,i) = mean( [v1,v2] );
 



