function lpict = jnd_region_segment( pict, dthresh, jnddata )

%  lpict = jnd_region_segment( pict, jnddata )

N = size(pict(:,:,1));


lpict = zeros( N(1),N(2) );
label = 0;

[j,i] = find( lpict == 0 ); % are there any seeds left
if ~isempty(j)
  
  label = label+1;
  
  j = j(1);
  i = i(1);
  colour = pict(j,i,:);
  stack = [ j(1) ; i(1) ; colour(:)];
  
  while ~isempty( stack )
    % pop
    j = stack(1,end);
    i = stack(2,end);
    colour = stack(3:5,end);
    stack = stack(:,1:end-1);
    if (1 <= j & j <= N(1)) & (1 <= i & i <= N(2))
      if lpict(j,i) == 0
        thiscolour = pict(j,i,:);
        thiscolour = thiscolour(:);
        d = jnd_distance( colour, thiscolour, jnddata );
      else
        d = Inf;
      end
    else
      d = Inf;
    end
    if d < dthresh
      lpict(j,i) = label;
      stack = [stack [j; i+1; thiscolour]];
      stack = [stack [j; i-1; thiscolour]];
      stack = [stack [j+1; i; thiscolour]];
      stack = [stack [j-1; i; thiscolour]];
    end
    
  end
  
  [j,i] = find( lpict == 0 ); % are there any seeds left

end

