function jnddata = jnd_sample_update( f, index, jnddata )

% jnddata = jnd_sample_update( jnddata, index, f )
% Update an existing sample point, given by index, using the values in f.

func = jnddata.func(:,index);
fold = func(1); % current function value
sold = func(2); % current standard deviation
Nold = func(3); % current number of observations

if Nold < 1         % the value has not been measured before
  fnew = mean(f);   % set value
  snew = std(f);    % fix standard deviation
  Nnew = length(f); % count trials
else
  M = length(f);
  fm = mean(f);
  
  Nnew = Nold + M; % update count
  fnew = (M*fm + Nold*fold) /Nnew; % update mean 
  snew = ((M-1)*var(f) + M*(fm - fnew).^2 + (Nold-1)*sold*sold + Nold*(fold - fnew).^2)/(Nnew-1);
  snew =sqrt(snew);

end  
jnddata.func(:,index) = [fnew; snew; Nnew]; 

return;

  