function jnddata = jnd_train_leaf( jnddata, tol, Nedge )

% jnddata = jnd_train_leaf( jnddata )
% Iterate over each leaf of the Octree, make sure each is to the satisfaction
% of the user.

% get  list of all leaves
leaf = [];
for i = 1:Octree_size( jnddata )
  if Octree_isleaf( jnddata, i )
    
    % the centre of the leaf
    index = Octree_getdata( jnddata, i );
    cornerp = jnddata.point(:, index );
    p = (max( cornerp, [], 2) + min( cornerp, [], 2 ))/2;
    
    jnddata = jnd_point_train( p, jnddata, tol, Nedge );
    
    % save here, just in case something goes wrong --- this precaution is
    % made because training is tedious
    save( 'jnd_train_leaf.mat', 'jnddata' );
  end
end

return;
