% pick a colour from a picture, and train the jnd model using that colour.

close all;
clear all;


tol = 1E-4;
Nedge = 49;

load 'jnddata';

pict = double( getpict(4) )/255;
figure;
imshow( pict );
drawnow;
f = gcf;

vpict = jnd_prob_pict( pict, jnddata ); % prob of being visible

figure;
imshow( vpict );
drawnow;
fv = gcf;

carry_on = 1;
while carry_on
  
  badinput = 1;
  while badinput
    fprintf('want to edit jnd model? (y/n)');
    sui = input('','s'); % string user input
    badinput = 0;
    switch( sui )
    case 'y'
    case 'n'
      carry_on = 0;
    otherwise
      badinput = 1;
    end
  end
  
  if carry_on
    figure(f);
    [i,j] = ginputCircle(1,3);
    p = pict(j,i,:);
    p = p(:);
    jnd = jnd_measure_trial( p, tol, Nedge );
    jnddata = jnd_grow( jnddata, p, jnd );
    % measure each of the new points
    jnddata = jnd_sample_check( jnddata, tol, Nedge );
    % and add auxilluary data
    jnddata = jnd_auxilluary_make( jnddata );
    
    vpict = jnd_prob_pict( pict, jnddata ); % prob of being visible
    figure( fv );
    imshow( vpict );
    
    % might want to ask to accept/reject the new jnd model
  end

end

save 'jnddata.mat' jnddata;
