close all;
clear all;

N = [64,64];
lpict = round( rand(N(1),N(2))*10 );

t = cputime;
[x,y] = meshgrid( 1:N(1), 1:N(2) );
m = [lpict(:), x(:), y(:)];
ms = sum( m(:,1) );
m(:,1) = m(:,1)/ms;
% estimate rarity as a cumulative probability
rpict1 = zeros( N(1), N(2) );
for i = 1:size(m,1)
  mask = m(:,1) < m(i,1); % (a) identify all locations with smaller M-distance
  rpict1( m(i,3), m(i,2) ) = sum( m(mask,1) );
end
t1 = (cputime - t)/prod(N);

t = cputime;
[x,y] = meshgrid( 1:N(1), 1:N(2) );
m = [lpict(:), x(:), y(:)];
ms = sum( m(:,1) );
m(:,1) = m(:,1)/ms;
m = sortrows( m );
rpict2 = zeros(N(1),N(2));
i = 1;
p = 0; % prob of being rare
while i <= size(m,1)
  current = m(i,1);
  accum = p;
  while i <= size(m,1) & m(i,1) == current
    rpict2( m(i,3),m(i,2) ) = p;
    accum = accum + m(i,1);
    i = i+1;
  end
  p = accum;
end
t2 = (cputime-t)/prod(N);

d = max(max(abs(rpict1-rpict2)))
[t1 t2]
