function [data,rpict] = training_getdata( pict, rpict, data, w,colour )

% [data,rpict] = training_getdata( pict, rpict, data, w,colour )
% get a list of points from the current picture, given a currently marked up copy
% in rpict, current data in data, a scale factor in w, and a colour to make marks, c.

Nsamples = 8*w;
theta = [0:Nsamples]*(2*pi/Nsamples);
x = (w+1)*cos(theta);
y = (w+1)*sin(theta);

imshow( rpict );

carry_on = 1;
while carry_on
  [i,j,b] = ginputCircle( 1, w );
  i = round(i);
  j = round(j);
  switch( b )
  case 1 % left button - include point
    sample = [i j];
    if ~ismember(sample,data,'rows')
      data = [data; sample];
      for k = 1:Nsamples
        rpict( round(j+y(k)), round(i+x(k)), : ) = colour;
      end
    end
  case 2 % middle button - quit
    carry_on = 0;
  case 3 % right button - remove point
    sample = [i j];
    k = ismember(data,sample,'rows');
    if any(k)
      k = find(k==1);
      data = [data(1:k-1,:); data(k+1:end,:)];
      for k = 1:Nsamples
        u = round(i+x(k));
        v = round(j+y(k));
        rpict( v, u, : ) = pict( v,u, :);
      end
    end
  end
  imshow( rpict );
end

return;


