close all;
clear all

Nsample = 16;
rad = 3;

load trainingdata;
 
Ntype = size( trainingdata.typename, 2);
[samplelocation(1,:), samplelocation(2,:)] = make_samples( Nsample );

Niter = 100;
tol = 1E-4;

% collect a set of features for each type from the training data
for i = 1: 1 %size( trainingdata.session,2)
  
  pict = pict_read( trainingdata.session{i}.fullname ); % read in the picture
  jpict = type_jpict4pict( trainingdata.session{i}.fullname ); % acquire a jnd map
  rad = trainingdata.session{i}.rad;
  
  for j = 1:Ntype
    
    F{j} = [];
    location = trainingdata.session{i}.location{j};
    for k = 1:size(location,2)
     
      % get a window
      w = location2window( pict, location(:,k), samplelocation, 1:rad );
      % get a jnd window too
      jw = location2window( jpict, location(:,k), samplelocation, 1:rad );
  
      % differential structure
      [da,dr] = window_radiff( w, pict(location(2,k),location(1,k),:) );
      
      % turn it into a feature
      f = type_window2feature( da, dr , jw, 1:rad  );
  
      F{j} = [ F{j} f];
      %       % record data about the feature
      %       featuredata.type(end+1) = j;
      %       featuredata.rad(end+1) = rad;
      %       featuredata.feature(:,end+1) = f;
      
    end % for k
    
  end % for j
  
  thisclassifier  = [];
  thisclassifier.Nsample = 16;
  thisclassifier.rad = rad;
  thisclassifier.Ntype = 5;
  for j = 1:Ntype
    thisclassifier.prior(j) = size( F{j}, 2 );
    N = ceil( size( F{j}, 2 ) /size(F{j},1) );
    gmm = [];
    pen = [];
    for k  = 1:N
      gmm{k} = GMM_fit( F{j}, k, Niter, tol );
      pen(k) = GMM_penalty( F{j}, gmm{k}, 6 );
    end
    [mpen,mk] = min( pen );
    thisclassifier.gmm{j} = gmm{mk};
  end
  thisclassifier.prior = thisclassifier.prior / sum( thisclassifier.prior );
  
end % for i

