function classifier = type_classifier_make( featuredata, rad )

% classifier = classifier_make( trainingdata, featuredata )
% Make a base classifier from the feature data

% copy sampling information
classifier.Nsample = featuredata.Nsample;
classifier.rad = featuredata.rad(1);
classifier.samplelocation = featuredata.samplelocation;

% copy the number of types
classifier.Ntype = featuredata.Ntype;

mask = zeros( size( featuredata.rad) );
for i = 1:size(rad)
  mask =  mask | (featuredata.rad == rad(i));
end


% Find a set of basis vectors
%classifier.eig = EigModel_make( featuredata.feature(:,mask) );


N = sum(mask);
for i = 1:classifier.Ntype
  data = featuredata.feature( :, (featuredata.type == i) & mask );
  classifier.prior(i) = size( data,2) / N;
  % data = [ data [data(1:end-1,:); -data(end,:)]]; don't work! why?
  % classifier.eig{i} = EigModel_make(  data );
  %data = EigModel_project( data, classifier.eig{i} );
  classifier.gmm{i} = GMM_make(  data, 100, 1E-3 );
end

return;

% % project data in that space
% pdata = EigModel_project( featuredata.feature, classifier.eig );
% pdata = featuredata.feature;
% 
% % and model the sample distribution of each training set
% N = size(pdata,2);
% for i = 1:featuredata.Ntype
%   mask = featuredata.type == i;
%   classifier.prior(i) = sum( mask ) / N;
%   classifier.gmm{i} = GMM_make( pdata(:,mask) , 100, 1E-3 );
% end

return;
