function featuredata = type_feature_data_make( trainingdata, Nsample)

% featuredata = type_feature_make( trainingdata, Nsample )
% Make featuredata from the training data using Nsample around each ring.


% load jnddata;

% Record sampling information
featuredata.Nsample = Nsample;

% make and record sample locations on the unit circle
[samplelocation(1,:), samplelocation(2,:)] = make_samples( Nsample );
featuredata.samplelocation = samplelocation;

% count the number of feature types
Ntype = size( trainingdata.typename, 2);
featuredata.Ntype = Ntype;

featuredata.type = [];
featuredata.rad = [];
featuredata.feature = [];

% collect a set of features for each type from the training data
for i = 1:size( trainingdata.session,2)
  pict = pict_read( trainingdata.session{i}.fullname ); % read in the picture
  jpict = type_jpict4pict( trainingdata.session{i}.fullname ); % acquire a jnd map
  rad = trainingdata.session{i}.rad;
  for j = 1:Ntype
    location = trainingdata.session{i}.location{j};
    for k = 1:size(location,2)
     
      % get a window
      w = location2window( pict, location(:,k), samplelocation, 1:rad );
      % get a jnd window too
      jw = location2window( jpict, location(:,k), samplelocation, 1:rad );
  
      % differential structure
      [da,dr] = window_radiff( w, pict(location(2,k),location(1,k),:) );
      
      % turn it into a feature
      f = type_window2feature( da, dr , jw, 1:rad  );
  
      % record data about the feature
      featuredata.type(end+1) = j;
      featuredata.rad(end+1) = rad;
      featuredata.feature(:,end+1) = f;
    end % for k
  end % for j
end % for i

return;
