function  frac = type_frac_ok( testtype, testdata, classifier )

%   frac = type_frac_ok( testdata, classifier )
% Measure the fraction of correctly classified data, given test data and a classifier.
% The tru type of each datum is in the corresponding element of testtype.

guesstype = zeros( 1, size( testdata,2 ) );

for i = 1:size( testdata,2 )
    p = type_feature_posterior( testdata(:,i), classifier );
    [dummy, guesstype(i)] = max(p);
end

frac = sum( testtype  == guesstype) / size(guesstype,2);

return;

