function  kpict = type_prob_pict( pict, classifier, rad, jpict )

%  kpict = type_prob_pict( pict, classifier, rad, scale, rad )
% Classify pixels in a picture.

N = size(pict);
samplelocation = classifier.samplelocation;

kpict = zeros(N(1),N(2),classifier.Ntype );

if nargin < 4
  jpict = jnd_pict( pict );
end

h = waitbar(0,'wait');
for j = (rad+1):(N(1)-rad)
  waitbar( j/ N(1), h );
  for i = (rad+1):(N(2)-rad)

    % grab a window
    w = location2window( pict, [i,j], samplelocation, 1:rad );
    % grab jnd data too
    jw = location2window( jpict, [i,j], samplelocation, 1:rad );
    
    % differential structure
    [da,dr] = window_radiff( w, pict(j,i,:) );
    
    % turn window into a feature
    f = type_window2feature( da, dr, jw, 1:rad );
    
    % compute classification probability vector
    kpict(j,i,:) = type_feature_posterior( f, classifier );
    
  end % for i
end % for j
close(h);

return;
% 
% load jnddata;
% 
% Nsample = classifier.Nsample;
% samplelocation= classifier.samplelocation;
% 
% N = size(pict);
% kpict = zeros(N(1),N(2),4 );
% % vpict = zeros(N(1),N(2),1);
% 
% for j = (rad+1):(N(1)-rad)
%   for i = (rad+1):(N(2)-rad)
%     % grab a window
%     w = location2window( pict, [i,j], samplelocation, 1:rad );
%    
%     % turn window into a feature
%     f = window2feature( w, pict(j,i,:), jnddata );
%     
%     % classifiy the feature
%     kpict(j,i,:) = feature_posterior( f , classifier );
% %     % classify the feature
% %     for k = 1:4
% %       m(k) = classifier.prior(k)*EigModel_likelihood( f, classifier.eig{k} ); %exp( -0.5*sum( ((f-ftm{k})./fts{k}).^2 ) ) / knf(k);
% %     end
% %     
% %     %[dummy,k] = min( m );
% %     ms = sum(m);
% %     if ms > 0
% %       kpict(j,i,:) = m/ms;
% %     end
% 
%   end
% end
% % figure;
% % imshow( kpict(:,:,2:end) );
% % 
% % figure;
% % imshow( vpict );
% % 
% % reclassify taking visibility into account
% % vkpict(:,:,1) = 1 - (1-kpict(:,:,1)).*vpict;
% % vkpict(:,:,2) = kpict(:,:,2).*vpict;
% % vkpict(:,:,3) = kpict(:,:,3).*vpict;
% % vkpict(:,:,4) = kpict(:,:,4).*vpict;
% 
% return;
% 
% 
% 
% kvpict(:,:,1) = 1 - (1-kpict(:,:,1)).*vpict;
% kvpict(:,:,2) = kpict(:,:,2).*vpict;
% kvpict(:,:,3) = kpict(:,:,3).*vpict;
% kvkpict(:,:,4) = kpict(:,:,4).*vpict;
% 
% 
% return;
% 
% 
% N = size(pict);
% 
% Ntype = size( classifier.gmm, 2 ); % number of types
% Nsample = classifier.Nsample;
% 
% ppict = zeros( N(1),N(2), Ntype );
% 
% samplelocation = classifier.samplelocation;
% 
% h = waitbar( 0, 'classifying');
% 
% r = max(rad);
% %r = max(classifier.rad);
% 
% iter = 0;
% Niter = (N(1)-r) - (r+1)-1;
% for j = (1+r):(N(1)-r)
% 
%   iter =iter+1;
%   waitbar(  iter/Niter, h );
%     
%   for i = (1+r):(N(2)-r)
%     
%     % get a window
%     [w, flag] = location2window( pict, [i,j], samplelocation, rad );
%     
%     % turn window to feature
%     f = window2feature( w );
%     
%     % classifiy feature
%     p = feature_posterior( f, classifier ); 
%     
%     ppict(j,i,:) = p;
%   end
% end
% close(h);
% % 
% % for j = 1:N(1) 
% %   for i = 1:N(2)
% %     ps = sum( ppict( j,i,:) );
% %     ppict(j,i,:) = ppict(j,i,:) / max( ps, eps );
% %   end
% % end
% 
% 
% 
% return;
% 
% 
% 
% h = waitbar( 0, 'classifying');
% q = zeros( Ntype, Nrad );
% area = N(1)*N(2);
% iter = 0;
% for i = 1:N(1)
%   for j = 1:N(2)
%     iter = iter+1;
%     waitbar(  iter/area, h );
%     q = 0*q;
%     for r = 1:Nrad
%       % get a window
%       [w, flag] = location2window( pict, [i,j], samplelocation, [0,r] );
%       if flag % sample is valid
%         % turn window to feature
%         f = window2feature( w );
%         
%         % classifiy feature
%         pf = EigModel_project( f, classifier.eig );
%         for k = 1:Ntype
%           p(k) = GMM_evidence( pf, classifier.gmm{k} ) * classifier.prior(k);
%         end
%         p = p / sum(p);
%         q(:,r) = p(:);
%       else
%         break;
%       end % if
%     end % r
%    
%     rmax = r-1;
%     if rmax > 0
%       % take account of the gain matrices
%       for r = 1:rmax
%         qq(:,r) = classifier.gain{r}*q(:,r);
%       end
%       qs = sum( qq(:,1:rmax), 1 );
%       qq(:,1:rmax) = qq(:,1:rmax) ./ repmat( qs, Ntype, 1);
%       
%       % decide class
%       p = sum(qq(:,1:rmax),2);
%       p = p / sum(p);
%       [dummy,k] = max( p ); % k is class of type
%       
%       % decide scale
%       [dummy, kk] = max( qq, [], 1 );
%       sk = find( kk == k );
%       sk = sk(1);
%       
%       ppict(j,i,:) = [k; sk; qq(:,sk) ];
%     end
% 
%   end
% end
% 
% close(h);
% 
% return;
