% Changing the sampling protocol
% * just a ring
% * a ring and its centre
% * a full disc
% Oddly, these are written in decending order of 'goodness', at least when
% small training sets are used.

close all;
clear all;

Nsample = 16;
rad = 3;

% initiate training data
if FileExists( 'type_trainingdata.mat' )
  load trainingdata;
else
  trainingdata = training_data_init;
end

trainingdata_old = trainingdata;
save 'trainingdataold.mat'  trainingdata_old;

% choose a picture
fprintf('---select a picture ---\n');
fullname = training_pict_choose( trainingdata );

% type_trainingdata_print( trainingdata );

% run a training session
fprintf('--- Collect training data  ---\n');
trainingdata = training_session( fullname, rad, trainingdata );
save 'trainingdata.mat'  trainingdata;

% make a set of features
fprintf('--- Making features ---\n');
featuredata = type_feature_data_make( trainingdata, Nsample );
save 'featuredata.mat'  featuredata;

% make a classifier
classifier = type_classifier_make( featuredata, rad );
save 'classifier.mat' classifier;

%frac = type_frac_ok( featuredata.type(mask), featuredata.feature(:,mask), classifier )

% classify the training picture
%pict = pict_read( fullname );

pict = getpict( 15 ); %6 );
pict = double( imread('../../images/stile.jpg') )/255;
figure;
imshow( pict );
drawnow;

jpict = jnd_pict( pict );
[samp(1,:), samp(2,:)] = make_samples( Nsample );
N = size( pict );
apict = zeros( N(1),N(2), 5 );
for r = 3:3
  fprintf('---type %d ---\n', r);
  kpict = type_prob_pict( pict, classifier, r, jpict );
  fprintf('---visibility %d ---\n', r);
  vpict = pict_prob_visible( pict, samp, r, jpict );
  fprintf('---rarity %d---\n', r );
  rpict = rare_prob_pict( pict, samp, 0:r );
  kvrpict(:,:,1) = kpict(:,:,1).*(1-vpict).*rpict;
  kvrpict(:,:,2) = kpict(:,:,2).*vpict.*rpict;
  kvrpict(:,:,3) = kpict(:,:,3).*vpict.*rpict;
  kvrpict(:,:,4) = kpict(:,:,4).*vpict.*rpict;
  kvrpict(:,:,5) = kpict(:,:,5).*vpict.*rpict;
  figure;
  imshow( kvrpict(:,:,2:end-1) );
  drawnow;
  apict = apict + kpict;
end
apict = apict / 6;


  
return;




