function feature = type_window2feature( da,dr, jw, r  )

% differential structure
% [da,dr] = window_radiff( w, wc );

r = r(:);
r = repmat( r, 1, size(da,2) );

% total colour change - the Laplacian
%dc = sqrt( sum((da + dr).^2,3) );
da(:,:,1) = da(:,:,1) ./ r;
da(:,:,2) = da(:,:,2) ./r;
da(:,:,3) = da(:,:,3) ./ r;
dc = sqrt( sum(da.^2 + dr.^2,3) );

% visibility
v = mean(mean( dc ./ jw(:,:,1) ));
% v  = 0.5*(1+erf( (d-1)/k )); 

% classify  the feature consider to total colour change in the tangential direction
% use only the outermost ring
d = sqrt( sum( da.^2, 3 ) );
d = d(end,:);
d = d / max(eps, sqrt(sum( sum(  d.*d ) ) ) );

feature = abs( fft(d,[],2) );     % the absolute FFT in the tangential direction only
feature = feature( :, 2:end ); % remove dc component
feature = feature( :, 1: ceil(size(feature,2)/2)  ); % do not need symmetric components
feature = feature'; % make a feature vector using rows (tangential components) 
feature = feature(:); % turned into columns

% d = sqrt( sum( dr.^2,3) );
% v = d ./ jw(:,:,1);
% d = v / max(eps, sqrt(sum( sum(  v.*v ) ) ) );
% d = d';
% feature = [feature; d(:)];

% append visibility
feature(end+1) = v;

return;

