close all;
clear all;

Human =[
  4.0 6.0;
  4.5 5.0;
  5.0 4.6;
  5.5 4.2;
  6.0 4.0]' / 6;


Martin = [
  0.6 5.5;
  1.5 5.2;
  3.0 4.5;
  4.5 3.5;
  5.4 1.9
]' / 6;


% dx = 0.1;
% x = 0:dx:1;
% ey = cell( size(x) );
% dy = cell( size(x) );
% ddy = cell( size(x) );
% ay = cell( size(x) );
ey = [];
dy = [];
ddy = [];
ay = [];

atestname{1} = 'stile';
atestname{2} = 'girl';
atestname{3} = 'car';
atestname{4} = 'taxi';
atestname{5} = 'venice';
atestname{6} = 'rushmore';

for t = 1:length(atestname)
  testname = atestname{t};
  
  switch( testname )
  case 'stile'
    truepict =  imread( 'stile copy.jpg' );
    load stile;
  case 'girl'
    truepict =  imread( 'e copy.jpg' );
    load e;
  case 'venice'
    truepict = imread('Venice02.small.copy.jpg');
    load 'venice'
  case 'rushmore'
    truepict = imread('rushmore.copy.jpg');
    load 'rushmore'
  case 'taxi'
    truepict = imread('taxi copy.jpg');
    load 'taxi';
  case 'car'
    truepict = imread('car2.copy.jpg');
    load 'car2';
  otherwise
    return;
  end
  
  
  pict = max( pict, [], 3);
  [u,v] = pictDerivs( pict, 1, 1 );
  spict = pictNorm( sqrt( u.^2 + v.^2 ) );
  
  % 
  kpict(:,:,1) = tpict(:,:,1).*cpict;
  kpict(:,:,2) = tpict(:,:,2).*cpict;
  kpict(:,:,3) = tpict(:,:,3).*cpict;
  kpict(:,:,4) = tpict(:,:,4).*cpict;
  kpict(:,:,5) = tpict(:,:,5).*cpict;
  ccpict = sum( kpict(:,:,2:end),3 );
  cccpict = sum( tpict(:,:,2:end), 3 );
  
  truepict = 1-double( truepict(:,:,2) >  200 );
  truepict = imdilate( truepict, ones(5,5) );
  truepict = double( truepict );
  trugnd = sum(sum(truepict));
  
  thresh = 0.0:0.1:1;
  
  for i = 1:length(thresh)
    
    % gd
    epict = spict >= thresh(i);
    eallobs = sum(sum(epict));
    etruobs = sum(sum(truepict.*epict));      % pixels detected as true
    if eallobs > 0
      eprec(i) = etruobs/eallobs;
    else
      eprec(i) = NaN;
    end
    erecl(i) = etruobs/trugnd;
    
    % canny
    if thresh(i) > 0
      if thresh(i) < 1        
        apict = double( edge( pict, 'canny', thresh(i) ) );
      else
        apict = zeros( size(pict) );
      end
    else
      apict = ones( size( pict ) );
    end
    aallobs = sum(sum(apict));
    atruobs = sum(sum(truepict.*apict));      % pixels detected as true
    if aallobs > 0
      aprec(i) = atruobs/aallobs;
    else
      aprec(i) = NaN;
    end
    arecl(i) = atruobs/trugnd;
    
    % us
    dpict = ccpict >= thresh(i);
    dallobs = sum(sum(dpict));
    dtruobs = sum(sum(truepict.*dpict));      % pixels detected as true
    if dallobs > 0
      dprec(i) = dtruobs/dallobs;
    else
      dprec(i) = NaN;
    end
    drecl(i) = dtruobs/trugnd;
    
     % us - again
    ddpict = cccpict >= thresh(i);
    ddallobs = sum(sum(ddpict));
    ddtruobs = sum(sum(truepict.*ddpict));      % pixels detected as true
    if ddallobs > 0
      ddprec(i) = ddtruobs/ddallobs;
    else
      ddprec(i) = NaN;
    end
    ddrecl(i) = ddtruobs/trugnd;
    
    
  end
  
  figure;
  hold on;
  h1 = plot( erecl, eprec, 'ko-' , 'MarkerFacecolor', 'k'); % gd
  h4 = plot( arecl, aprec, 'k^-', 'Markerfacecolor', 'k' ); % canny
  %h2 = plot( drecl, dprec, 'ms-','MarkerFacecolor', 'm'  );% us_1
  h3 = plot( ddrecl, ddprec, 'ks-','MarkerFacecolor', 'k'  ); % us_2
  ho = plot( Human(1,:), Human(2,:), 'k' );
  hm = plot( Martin(1,:), Martin(2,:), 'k-.');
  xlabel( 'recall');
  ylabel('precision');
  legend( [h1, h4, h3, hm, ho], 'GD', 'Canny', 'us' ,'Martin et al.', 'Human');
  title( testname );
%   
%   alpha = 0.5;
%   ef = (erecl .* eprec) ./ (alpha*erecl + (1-alpha)*eprec );
ey = [ey [erecl; eprec]];
dy = [dy [drecl; dprec]];  
ddy = [ddy [ddrecl; ddprec]];  
ay = [ay [arecl; aprec]];  

%   % transfer the recall/precision curves into a bin
%   for i = 1:length(erecl)
%     j = 1+floor( erecl(i)/dx );
%     ey{j} = [ey{j} eprec(i)];
%     
%     j = 1+ floor( drecl(i)/dx );
%     dy{j} = [dy{j} dprec(i)];
%     
%     j = 1 + floor( ddrecl(i)/dx );
%     ddy{j} = [ddy{j} ddprec(i) ];
%     
%     j = 1+ floor( arecl(i)/dx );
%     ay{j} = [ ay{j} aprec(i) ];
%   end
  
end



figure;
hold on;
h1 = plot( ey(1,:), ey(2,:), 'b.' );
h2 = plot( dy(1,:), dy(2,:), 'r.'  );
h3 = plot( ddy(1,:), ddy(2,:), 'm.'  );
h4 = plot( ay(1,:), ay(2,:), 'k.' );
xlabel( 'recall');
ylabel('precision');
title( 'all'  );
% 
% 
% [ep,es,emu] = polyfit( ey(1,:), ey(2,:), 2 );
% [dp,ds,dmu] = polyfit( dy(1,:), dy(2,:), 2 );
% [ddp,dds,ddmu] = polyfit( ddy(1,:), ddy(2,:), 2 );
% [ap,as,amu] = polyfit( ay(1,:), ay(2,:), 2 );
% 
% 
% figure;
% hold on;
% h1 = plot( x, polyval( ep,x,es,emu), 'b' );
% h2 = plot( x, polyval( dp,x,ds,dmu), 'r' );
% h3 = plot( x, polyval( ddp,x,dds,ddmu), 'm' );
% h4 = plot( x, polyval( ap,x,as,amu), 'k' );



% 
% for i = 1:length(x)
%   ez(i) = mean( ey{i} );
%   dz(i) = mean( dy{i} );
%   ddz(i) = mean( ddy{i} );
%   az(i) = mean( ay{i} );
% end
% 
% figure;
% hold on;
% plot( x, ez );
% plot( x, dz, 'r' );
% plot( x, ddz, 'm' );
% plot( x, az, 'k' );

