close all;
clear all;

pict = getpict(1);
imshow( pict );

%jpict = jnd_pict(pict);
load jndpict;
%imshow( jpict(:,:,1),[] );

N = size(pict);
spict = zeros( N(1), N(2) ); % scale picture
sigma = 1; % current scale
while any(any(spict == 0))
  % make a probably-visible picture at the scale
  [ rupict,  rvpict ]  = pictDerivs( pict(:,:,1),  sigma, 1 );
  [ gupict, gvpict ] = pictDerivs( pict(:,:,2), sigma, 1 );
  [ bupict, bvpict ] = pictDerivs( pict(:,:,3), sigma, 1 );
  upict = sqrt( rupict.^2 + bupict.^2 + gupict.^2);
  vpict = sqrt( rvpict.^2 + bvpict.^2 + gvpict.^2);
  dpict = sqrt(upict.^2 + vpict.^2);
  ppict = 0.5*(erf( (dpict-jpict(:,:,1))./jpict(:,:,2) ) + 1);
  mask = (ppict > 0.5) & (spict == 0);
  spict = spict.*(1-mask) + sigma*mask; 
  figure(2);
  imshow( mask );
  figure(3);
  imshow( spict, [] );
  sigma = sigma+1;
end



load classifier;
scalemax = 6;
Nsamp = 16; % use 16 samples

[samp(1,:), samp(2,:)] = make_samples( Nsamp ); % sample around the unit circle
tpict = zeros( N(1),N(2), 5);
cpict = zeros( N(1),N(2) );
mpict = cell( N(1),N(2) );
load 'coherencedata.mat';
for j = 1:N(1)
  for i = 1:N(2)
    scale = 3*spict(j,i);
    if (i-scale > 0) & (j-scale >0) &(i+scale <= N(2)) & (j+ scale <= N(1))
      % window
      w = location2window( pict, [i;j], samp, 1:scale );
       % grab jnd data too
      jw = location2window( jpict, [i,j], samp, 1:scale );
      % differential structure
      [da,dr] = window_radiff( w, pict(j,i,:) );   
      
      for s = 1:scale
        f = type_window2feature( da( 1:s, : ,:), dr(1:s, :,: ), jw(1:s,:,: ), 1:s );
        p = type_feature_posterior( f, classifier );
        [mp,t] = max(p);
        mpict{j,i} = [mpict{j,i} t];
      end
%       [cpict(j,i),mpict(j,i)] = coherence_window_prob( w, coherencedata );
%       

%       % turn window into a feature
%       f = type_window2feature( da, dr, jw, 1:scale );
%       % compute classification probability vector
%       tpict(j,i,:) = type_feature_posterior( f, classifier );
    
    end
  end
end

cpict = 0*cpict;
for j = 1:N(1)
  for i = 1:N(2)
    cpict(j,i) = std( mpict{j,i} );
  end
end


return;

mu = 0.1;
sigma = 0.1;
ccpict = 1- (erf( (mpict - mu)/sigma )+1)/2;
%figure;
%imshow( ccpict );

kpict(:,:,1) = tpict(:,:,1).*(1-ppict).*ccpict;
kpict(:,:,2) = tpict(:,:,2).*ppict.*ccpict;
kpict(:,:,3) = tpict(:,:,3).*ppict.*ccpict;
kpict(:,:,4) = tpict(:,:,4).*ppict.*ccpict;
kpict(:,:,5) = tpict(:,:,5).*ppict.*ccpict;

%kpict = type_prob_pict( pict, classifier, scale, jpict ); % class

figure;
imshow( kpict(:,:,2:4) );

return;

while 1
  figure(1);
  imshow(pict);
  [i,j,b] = ginput(1);
  i= round(i);
  j= round(j);
  if b == 2
    break;
  end
  scale = 3*spict(j,i);
  if (i-scale > 0) & (j-scale >0) &(i+scale <= N(2)) & (j+ scale <= N(1))
    w = pict( j-scale:j+scale, i-scale:i+scale, : );
    figure(2);
    imshow( w );
  end
end

return;

% spict gives the scale at which a pixel is visible
% but is the window coherent at that scale?




