# getMEXT - determine the correct mex extension for the current OS and CPU

## This file is part of the SaliencyToolbox - Copyright (C) 2006-2007
## by Dirk B. Walther and the California Institute of Technology.
## See the enclosed LICENSE.TXT document for the license agreement. 
## More information about this project is available at: 
## http://www.saliencytoolbox.net

if [ ${TERM} == msys ]
then
  if [ -z "${MATLABROOT}" ]
  then
    echo error
    echo MATLABROOT must be defined! >/dev/stderr
    exit 1
  fi
  if [ -d "${MATLABROOT}" ]
  then
    echo dll
    exit 0
  else
    echo error
    echo MATLABROOT: ${MATLABROOT} is not a valid directory! >/dev/stderr
    exit 2
  fi
else
  me=`which mexext 2>/dev/null`
  if [ -x "$me" ]
  then
    mexext
  else
    echo "#include <mex.h>" > dummy.c
    echo "void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
  {}" >> dummy.c
    mex dummy.c
    rm dummy.c
    fname=`ls dummy.*`
    echo ${fname#dummy.}
    rm ${fname}
  fi
fi
